/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package business;

import domain.Product;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.ConcurrencyManagement;
import javax.ejb.ConcurrencyManagementType;
import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.Singleton;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

/**
 *
 * @author hardebolle
 */
@Singleton
@ConcurrencyManagement(ConcurrencyManagementType.CONTAINER)
public class CatalogSingleton {
    
    @PersistenceContext(unitName = "cqpasiPU")
    private EntityManager em;

    
    public List<Product> getProductList() {
        TypedQuery<Product> q =
               //this.em.createQuery("SELECT p FROM Product p", Product.class);
                this.em.createNamedQuery("getAllProducts", Product.class);

        return q.getResultList();
    }
   
    public void add(Product p) {
        if(p!=null){
            this.em.persist(p);
        }
    }

    public void delete(Product p) {
        this.em.remove(this.em.merge(p));
    }
    
}
